// |-------------------------------------------|
// | Antifreeze Hack                           |
// | by: madsiur, C-Dude                       |
// | version: 1.1                              |
// | released on: June 29th, 2024              |
// | apply to: FF3us 1.0 (no header)           |
// |-------------------------------------------|

arch snes.cpu

macro seek(variable offset) {
  origin (offset & $3FFFFF)
  base offset
}

// equipment properties setting hook
seek($C2291A)
jsl free_space_a
nop

// monster properties setting hook
seek($C22E21)
jsl free_space_b
nop
nop

// new code
seek($EEAF01)       // you can change this free space offset as long as it's not in bank $C2
free_space_a:
eor $D2             // equipment immunities
ora #$0008          // exclude magitek
sta $331C,x         // make not vulnerable to
lda #$FFFF          // start by assuming nothing is blocked
sta $3300,x         // save as blocked statuses 3 and 4 for this character
lda $D2             // equipment immunities
bit #$0008          // check if the "repel magitek" flag is set
beq exit_a          // exit if not
lda $3300,x         // status byte 3 and 4 for this character
and #$FDFF          // remove Freeze bit
sta $3330,x         // make not vulnerable to Freeze
exit_a:
rtl

free_space_b:
and $331C,y         // original code
ora #$0008          // exclude magitek
sta $331C,y         // original code
lda $CF0014,x       // monster blocked status bytes 1-2
bit #$0008          // check if the "block magitek" flag is set
beq exit_b          // exit if not
lda #$FDFF          // not vulnerable to Freeze
and $3330,y
sta $3330,y         // make monster not vulnerable to Freeze
exit_b:
rtl